//------------------------------------------------------------------------------

extern void InitMarkLib( Tcl_Interp* i, char* c );

//------------------------------------------------------------------------------

class Mark
{
protected:
   const int min_width = 1;
   const int max_width = 5;

   Vertex* v;
   char* label;
   MN_Point pos, size;
   MN_Color fill, blank, outline;
   float thickness, fillPercentage;
   int label_widget, label_chars;

public:
   Mark( Vertex* u, MN_Point* p, MN_Point* s, char* l )
   {
      v = u;
      pos = *p;
      size = *s;
      label = l;
      label_chars = strlen( label );
      fill.Set( 0, 0, 0 );
      blank.Set( 255, 255, 255 );
      outline.Set( 0, 0, 0 );
      thickness = 1.0;
      fillPercentage = 1.0;
   };
   virtual void Display( void ) = 0;
   virtual void Show( bool s ) = 0;
   virtual void SetPos( MN_Point *p ) = 0;
   virtual void SetSize( MN_Point *p ) = 0;
   virtual void SetFill( MN_Color *p ) = 0;
   virtual void SetBlank( MN_Color *p ) = 0;
   virtual void SetOutline( MN_Color *p ) = 0;
   virtual void SetThickness( float p ) = 0;
   virtual void SetFillPercentage( float p ) = 0;
   void		SetLabelLength( int l )
		{
		   label_chars = l;
		};
};

//------------------------------------------------------------------------------

class Meter : public Mark
{
protected:
   int big_rect, small_rect;

public:
		Meter( Vertex* v, MN_Point* p, MN_Point* s, char* label );
   virtual void Display( void ) = 0;
   virtual void Show( bool s );
   virtual void SetPos( MN_Point *p );
   virtual void SetSize( MN_Point *p );
   virtual void SetFill( MN_Color *p );
   virtual void SetBlank( MN_Color *p );
   virtual void SetOutline( MN_Color *p );
   virtual void SetThickness( float p );
   virtual void SetFillPercentage( float p ) = 0;
};

//------------------------------------------------------------------------------

class VMeter : public Meter
{
public:
		VMeter( Vertex* v, MN_Point* p, MN_Point* s, char* l )
		: Meter( v, p, s, l ) {};
   virtual void Display( void );
   virtual void SetFillPercentage( float p );
};

//------------------------------------------------------------------------------

class HMeter : public Meter
{
public:
		HMeter( Vertex* v, MN_Point* p, MN_Point* s, char* l )
		: Meter( v, p, s, l ) {};
   virtual void Display( void );
   virtual void SetFillPercentage( float p );
};

//------------------------------------------------------------------------------

class Gauge : public Mark
{
protected:
   int fillA, circleA;

public:
		Gauge( Vertex* v, MN_Point* p, MN_Point* s, char* label );
   virtual void Display( void );
   virtual void Show( bool s );
   virtual void SetPos( MN_Point *p );
   virtual void SetSize( MN_Point *p );
   virtual void SetFill( MN_Color *p );
   virtual void SetBlank( MN_Color *p );
   virtual void SetOutline( MN_Color *p );
   virtual void SetThickness( float p );
   virtual void SetFillPercentage( float p );
};

//------------------------------------------------------------------------------

class Icon : public Mark
{
protected:
   int bitmap, rect;

public:
		Icon( Vertex* v, MN_Point* p, MN_Point* s, char* label );
   void		SetBitmap( char* id );
   virtual void Display( void );
   virtual void Show( bool s );
   virtual void SetPos( MN_Point *p );
   virtual void SetSize( MN_Point *p );
   virtual void SetFill( MN_Color *p );
   virtual void SetBlank( MN_Color *p ) {};
   virtual void SetOutline( MN_Color *p );
   virtual void SetThickness( float p );
   virtual void SetFillPercentage( float p ) {};
};

//------------------------------------------------------------------------------
